<template>
  <input
    :type="type"
    :class="$style.inputText"
    :name="name"
    :disabled="disabled"
    v-model="value"
    :placeholder="placeholder"
    @input="onChange"
  />
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  name: "BaseInput",
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    defaultValue: {
      type: String,
      required: false,
      default: ""
    },
    name: {
      type: String,
      required: true,
      default: ""
    },
    type: {
      type: String,
      required: false,
      default: "text"
    },
    placeholder: {
      type: String,
      required: false,
      default: ""
    }
  },
  data: function() {
    return {
      value: this.defaultValue || ""
    };
  },
  methods: {
    onChange: function($event: EventListenerOrEventListenerObject) {
      this.$emit("onChange", $event, this.value, this.name);
    }
  }
});
</script>

<style module lang="scss">
.inputText {
  width: auto;
  border: none;
  padding: 1rem 1rem;
  box-shadow: $shadow--default;
}
</style>
